У меня есть этот код

/* GET */
router.get('/mycol', function(req, res) {
  var db = req.db;
  var collection = db.get('mycol');
  collection.find({}, {}, function(err, docs) {
    res.json(docs);
  });
});

/* POST */
router.post('/mycol', function(req, res) {

  var db = req.db;
  var collection = db.get('mycol');

  collection.insert({"test":"testing"}, function(err, docs) {
    if (err) {
      res.json({"error":err});
    }
    else {
      res.json(docs);
    }
  });

});

GET работает нормально, а POST - нет - вставка возвращает ошибку, а ошибка json просто:

{"error":{"name":"MongoError"}}

Та же самая вставка отлично работает, если я ввожу ее в консоль mongo следующим образом:

> db.mycol.insert({"test":"testing"})
WriteResult({ "nInserted" : 1 })

Я новичок в node.js, пока все кажется хорошо, кроме этого ... полностью застрял на нем, не уверен, что попробовать

Редактировать:

Это мой код app.js, это проблема с маршрутами? Может быть, db прикреплен к объекту req для GET, но не POST? ...

var express = require('express');
var path = require('path');
var favicon = require('serve-favicon');
var logger = require('morgan');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');

var mongo = require('mongodb');
var monk = require('monk');
var db = monk('localhost:27017/skdb');

var routes = require('./routes/index');
var users = require('./routes/users');

var app = express();

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');

// uncomment after placing your favicon in /public
//app.use(favicon(path.join(__dirname, 'public', 'favicon.ico')));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

// Make our db accessible to our router
app.use(function(req,res,next){
    req.db = db;
    next();
});

app.use('/', routes);
app.use('/users', users);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  var err = new Error('Not Found');
  err.status = 404;
  next(err);
});

// error handlers

// development error handler
// will print stacktrace
if (app.get('env') === 'development') {
  app.use(function(err, req, res, next) {
    res.status(err.status || 500);
    res.render('error', {
      message: err.message,
      error: err
    });
  });
}

// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res, next) {
  res.status(err.status || 500);
  res.render('error', {
    message: err.message,
    error: {}
  });
});


module.exports = app;
-1
jonydep 28 Фев 2016 в 23:19

2 ответа

Лучший ответ

Вам необходимо создать .message из экземпляра MongoError, чтобы диагностировать вашу проблему.

http://mongodb.github.io/node-mongodb-native/core/api/MongoError.html

По вопросу версии:

Monk использует MongoDB и Mongoskin 1.4, см. Package.json здесь: https://github.com/Automattic/monk/blob/master/package.json

Вероятно, вам понадобится другой модуль (например, пакет узла MongoDB), который поддерживает более поздние версии драйверов.

В npm установите монаха:

npm WARN peerDependencies The peer dependency mongodb@~1.4 included from mongoskin will no
npm WARN peerDependencies longer be automatically installed to fulfill the peerDependency
npm WARN peerDependencies in npm 3+. Your application will need to depend on it explicitly.

//other stuff

├── mpromise@0.5.1
├── debug@2.2.0 (ms@0.7.1)
├── mongodb@1.4.40 (kerberos@0.0.11, bson@0.2.22)
└── mongoskin@1.4.13
1
Devnetics 28 Фев 2016 в 21:17

Как говорит Kinetics в комментарии - просто нужно было посмотреть res.json (err.message), а не просто res.json (err)

Оказывается, у меня есть эта проблема: MongoError: драйвер несовместим с этой версией сервера

0
Community 23 Май 2017 в 11:54